SystemOrganization addCategory: #'Rest-Tests'!
SystemOrganization addCategory: #'Rest-Tests-Server'!
SystemOrganization addCategory: #'Rest-Tests-Fixtures'!
SystemOrganization addCategory: #'Rest-Tests-Client'!
SystemOrganization addCategory: #'Rest-Tests-Prefetch'!

ActiveHandRestSocket subclass: #TestActiveHandRestSocket
	instanceVariableNames: 'currentLogin currentPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!TestActiveHandRestSocket methodsFor: 'as yet unclassified' stamp: 'bs 9/9/2009 12:11'!
userNamePasswordIfExists
	^ ActiveHand providesLoginAndPassword 
		ifFalse: ['']
		ifTrue: [
			'Authorization: Basic ',
			((Base64MimeConverter mimeEncode: 
			(ActiveHand login, ':', ActiveHand password) readStream) upToEnd select: [:c | c ~= Character cr]), 
			String crlf.]! !

RestEntity subclass: #RestTestEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

RestTestEntity class
	instanceVariableNames: 'lastId'!

RestTestEntity class
	instanceVariableNames: 'lastId'!

RestTestEntity subclass: #RestSecondLevelTestObject
	instanceVariableNames: 'testObject testObject2 userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestSecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 3/5/2009 17:21'!
newFrom: aDictionary

	^ self new userName: (aDictionary at: 'userName')! !

!RestSecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'cs 4/25/2009 15:53'!
primitivePropertyNames

	^ super primitivePropertyNames, #(userName)! !

!RestSecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'cs 4/25/2009 15:54'!
referencePropertyNames

	^ super referencePropertyNames, #(testObject)! !

!RestSecondLevelTestObject methodsFor: 'deleting' stamp: 'cs 3/17/2009 18:44'!
delete

	self testObject removeSecondLevelTestObject: self.
	self testObject2 removeSecondLevelTestObject: self.! !

!RestSecondLevelTestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:08'!
testObject

	^ testObject! !

!RestSecondLevelTestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:42'!
testObject2

	^ testObject2! !

!RestSecondLevelTestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:42'!
testObject2: aTestObject

	aTestObject ifNil: [testObject2 := nil. ^ self].
	testObject2 ifNotNil: [testObject2 secondLevelTestObjects remove: self. testObject2 := nil].
	aTestObject addSecondLevelTestObject: self.
	testObject2 := aTestObject.! !

!RestSecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/16/2009 17:17'!
testObject: aTestObject

	aTestObject ifNil: [testObject := nil. ^ self].
	testObject ifNotNil: [testObject secondLevelTestObjects remove: self. testObject := nil].
	aTestObject addSecondLevelTestObject: self.
	testObject := aTestObject.! !

!RestSecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/5/2009 16:25'!
userName
	^ userName! !

!RestSecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/5/2009 16:25'!
userName: aString 
	userName := aString! !

!RestTestEntity class methodsFor: 'description' stamp: 'cs 5/19/2009 18:26'!
handlerClass

	^ RestMockResourceHttpHandler! !

RestTestEntity subclass: #RestTestObject
	instanceVariableNames: 'userName secondLevelTestObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestTestObject class methodsFor: 'accessing' stamp: 'cs 5/13/2009 11:23'!
collectionPropertyNames

	^ super collectionPropertyNames, #(secondLevelTestObjects secondLevelTestObjectsWithDeleted)! !

!RestTestObject class methodsFor: 'instance creation' stamp: 'mt 3/4/2009 14:17'!
newFrom: aDictionary

	^ self new
		userName: (aDictionary at: 'userName')! !

!RestTestObject class methodsFor: 'accessing' stamp: 'cs 4/25/2009 15:54'!
primitivePropertyNames

	^ super primitivePropertyNames, #(userName)! !

!RestTestObject methodsFor: 'add-remove' stamp: 'cs 5/28/2009 17:24'!
addNewSecondLevelTestObject: aDictionary

	^ self addSecondLevelTestObject:
		(RestSecondLevelTestObject newFrom: aDictionary)! !

!RestTestObject methodsFor: 'add-remove' stamp: 'cs 5/28/2009 17:24'!
addSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects add: aSecondLevelTestObject ifPresent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject
		handler: self handler;
		testObject: self.
	^ aSecondLevelTestObject! !

!RestTestObject methodsFor: 'deleting' stamp: 'cs 5/28/2009 17:50'!
delete

	self handler root removeTest: self.! !

!RestTestObject methodsFor: 'initializing' stamp: 'topa 3/3/2009 22:11'!
initialize

	super initialize.
	self secondLevelTestObjects: OrderedCollection new.! !

!RestTestObject methodsFor: 'add-remove' stamp: 'SR 2/26/2009 15:29'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject: nil.
	^ aSecondLevelTestObject! !

!RestTestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:12'!
secondLevelTestObjects

	^ secondLevelTestObjects! !

!RestTestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:12'!
secondLevelTestObjects: anObject

	secondLevelTestObjects := anObject.! !

!RestTestObject methodsFor: 'accessing' stamp: 'mt 4/16/2009 16:28'!
secondLevelTestObjectsWithDeleted

	^ secondLevelTestObjects! !

!RestTestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:27'!
userName

	^ userName! !

!RestTestObject methodsFor: 'accessing' stamp: 'cs 3/17/2009 18:27'!
userName: anObject

	userName := anObject.! !

RestTestObject subclass: #RestTestObject2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestTestObject2 methodsFor: 'add-remove' stamp: 'cs 5/28/2009 17:30'!
addSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects add: aSecondLevelTestObject ifPresent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject
		handler: self handler;
		testObject2: self.
	^ aSecondLevelTestObject! !

!RestTestObject2 methodsFor: 'deleting' stamp: 'cs 5/28/2009 17:50'!
delete

	self handler root removeTest2: self.! !

!RestTestObject2 methodsFor: 'add-remove' stamp: 'cs 3/17/2009 18:44'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject2: nil.
	^ aSecondLevelTestObject! !

RestEntity subclass: #RestTestRoot
	instanceVariableNames: 'tests tests2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestTestRoot class methodsFor: 'resources' stamp: 'cs 5/28/2009 15:23'!
collectionPropertyNames

	^ #(tests tests2)! !

!RestTestRoot class methodsFor: 'instance creation' stamp: 'cs 6/12/2009 16:10'!
testData

	| secondLevels |
	secondLevels := (1 to: 3) collect: [:i |
		RestSecondLevelTestObject new userName: 'SecondLevel ', i asString].
	^ self new
		addTest: (RestTestObject new
			userName: 'Test Project';
			id: 1;
			addSecondLevelTestObject: secondLevels first;
			addSecondLevelTestObject: secondLevels second;
			addSecondLevelTestObject: secondLevels third;
			yourself);
		addTest: (RestTestObject new
			userName: 'Test3 Project3';
			id: 3);
		addTest: (RestTestObject new
			userName: 'NewTestOnTheBlock');
		addTest2: (RestTestObject2 new
			userName: 'Test2 Project2';
			id: 2;
			addSecondLevelTestObject: secondLevels first;
			yourself);
		yourself! !

!RestTestRoot methodsFor: 'add-remove' stamp: 'cs 5/28/2009 16:19'!
addNewTest2: aDictionary 

	^ self addTest2: (RestTestObject2 newFrom: aDictionary)! !

!RestTestRoot methodsFor: 'add-remove' stamp: 'cs 5/28/2009 16:19'!
addNewTest: aDictionary 

	^ self addTest: (RestTestObject newFrom: aDictionary)! !

!RestTestRoot methodsFor: 'add-remove' stamp: 'cs 5/28/2009 17:22'!
addTest2: aTestObject 

	self tests2 add: aTestObject.
	^ aTestObject handler: self handler! !

!RestTestRoot methodsFor: 'add-remove' stamp: 'cs 5/28/2009 17:22'!
addTest: aTestObject 

	self tests add: aTestObject.
	^ aTestObject handler: self handler! !

!RestTestRoot methodsFor: 'initialization' stamp: 'cs 5/28/2009 15:50'!
initialize

	super initialize.
	self
		tests: OrderedCollection new;
		tests2: OrderedCollection new! !

!RestTestRoot methodsFor: 'add-remove' stamp: 'cs 5/28/2009 16:19'!
removeTest2: aTestObject
	
	^ self tests2 remove: aTestObject! !

!RestTestRoot methodsFor: 'add-remove' stamp: 'cs 5/28/2009 16:19'!
removeTest: aTestObject
	
	^ self tests remove: aTestObject! !

!RestTestRoot methodsFor: 'accessing' stamp: 'cs 5/28/2009 14:42'!
tests

	^ tests! !

!RestTestRoot methodsFor: 'accessing' stamp: 'cs 5/28/2009 14:42'!
tests2

	^ tests2! !

!RestTestRoot methodsFor: 'accessing' stamp: 'cs 5/28/2009 14:42'!
tests2: anObject

	tests2 := anObject.! !

!RestTestRoot methodsFor: 'accessing' stamp: 'cs 5/28/2009 14:42'!
tests: anObject

	tests := anObject.! !

RestHttpHandler subclass: #RestPerformHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestPerformHttpHandler class methodsFor: 'handling' stamp: 'cs 5/20/2009 16:43'!
pathPattern

	^ super pathPattern , 'perform'! !

!RestPerformHttpHandler methodsFor: 'request processing' stamp: 'cs 5/28/2009 15:25'!
process: anHTTPRequest
	"Takes first element in path as classname and sends message from third path element to that class."

	| pc class selector result |
	pc := self pathComponents: anHTTPRequest.
	class := pc first asSymbol.
	selector := pc second asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [result := c perform: selector]].

	^ HTTPResponse ok entity: result asString! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandler class methodsFor: 'handling' stamp: 'cs 5/28/2009 16:14'!
pathPattern

	^ super pathPattern , 'test'! !

!RestMockResourceHttpHandler class methodsFor: 'resources' stamp: 'cs 5/28/2009 16:15'!
rootResource

	^ RestTestRoot new! !

!RestMockResourceHttpHandler class methodsFor: 'resources' stamp: 'cs 6/4/2009 14:10'!
uriMapping

	^ Dictionary newFrom: { 
		RestTestObject -> [:test | '/tests/{1}' format: {test id} ].
		RestTestObject2 -> [:test | '/tests2/{1}' format: {test id}].
		RestSecondLevelTestObject ->  [:test | 
			'/tests/{1}/secondLevelTestObjects/{2}' format: {test testObject id. test id}]}! !

RestMockResourceHttpHandler subclass: #RestMockResourceHttpHandlerAuth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandlerAuth methodsFor: 'authentication' stamp: 'topa 3/5/2009 11:25'!
needsAuthentication

	^ true! !

TestCase subclass: #RestSocketTestCase
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'topa 3/3/2009 21:52'!
httpUrl

	^ 'http://www.google.com' asUrl! !

!RestSocketTestCase methodsFor: 'tests' stamp: 'mt 6/21/2010 09:55:49.724'!
testDefaultReturn

	[self
		should: ((RestSocket get: self class httpUrl) isKindOf: RestResponse);
		should: ((RestSocket putDocumentFromUrl: self class httpUrl request: '' content: 'foo') isKindOf: RestResponse);
		should: ((RestSocket postDocumentFromUrl: self class httpUrl request: '' content: 'bar') isKindOf: RestResponse);
		should: ((RestSocket deleteDocumentFromUrl: self class httpUrl request: '') isKindOf: RestResponse).	
	] on: NetworkError do: [:e | self assert: false description: e description]! !

TestCase subclass: #RestTest
	instanceVariableNames: 'currentLogin currentPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

RestTest subclass: #RestDynamicVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestDynamicVariableTest methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 16:19'!
setUp
	"no upcall"! !

!RestDynamicVariableTest methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 16:19'!
tearDown
	"no upcall"! !

!RestDynamicVariableTest methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 16:26'!
testNoValue
	
	self should: RestMockVariable value = RestMockVariable defaultValue.! !

!RestDynamicVariableTest methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 16:25'!
testValue
	
	RestMockVariable
		use: 'test'
		during: [self should: RestMockVariable value = 'test'].! !

RestTest subclass: #RestHttpServiceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestHttpServiceTest methodsFor: 'running' stamp: 'topa 2/25/2009 13:28'!
setUp
	"avoid upcall"! !

!RestHttpServiceTest methodsFor: 'tests' stamp: 'topa 2/26/2009 19:39'!
testStartAndStop
	
	RestHttpService startOn: self class port.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isKindOf: RestHttpService);
		should: RestHttpService isRunning.
	
	RestHttpService stop.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isNil);
		shouldnt: RestHttpService isRunning.! !

RestTest subclass: #RestJsonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestJsonTest methodsFor: 'as yet unclassified' stamp: 'mt 4/21/2009 10:27'!
testNumberSerialization

	#(1 1.0 1/2 20.42) do: [:num | self should: (Json readFrom: (Json render: num) readStream) = num].! !

RestTest subclass: #RestNotImplementedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestNotImplementedTest methodsFor: 'tests' stamp: 'cs 5/28/2009 16:05'!
testHTTPWrongVerb

	| response |
	RestHttpService resource installHandler: RestMockResourceHttpHandler new.
	response := RestSocket
		doHTTPRequestFromUrl: (self class url, 'tests/') asUrl
		verb: 'HEAD'
		request: ''
		content: nil.
	self 
		should: RestHttpService isRunning;
		should: response isNotImplemented.! !

RestTest subclass: #RestPerformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestPerformTest class methodsFor: 'fixture-data' stamp: 'cs 5/22/2009 14:18'!
path

	^ RestPerformHttpHandler pathPattern! !

!RestPerformTest methodsFor: 'running' stamp: 'cs 5/28/2009 16:05'!
setUp

	super setUp.
	RestHttpService resource installHandler: RestPerformHttpHandler new.! !

!RestPerformTest methodsFor: 'tests' stamp: 'cs 5/22/2009 14:19'!
testPort

	| response |
	response := self get: 'RestHttpService/port'.
	self should: response content = RestHttpService port asString.! !

RestTest subclass: #RestPrefetchTest
	instanceVariableNames: 'testData testObject proxyObject proxyRepository testCollection proxyCollection testSecondLevel proxySecondLevel testObject2 testObject3 proxyObject2 proxyObject3 testSecondLevels proxySecondLevels proxySecondLevels2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Prefetch'!

!RestPrefetchTest methodsFor: 'running' stamp: 'cs 6/12/2009 15:36'!
setUp

	"Install a handler for http service. Get prefetch proxy collection."
	super setUp.
	RestSocket resetCounter.
	testData := RestTestRoot testData.
	proxyRepository := RestPrefetchProxyRepository fromString: self class url.
	RestHttpService resource installHandler: (RestMockResourceHttpHandler with: testData).
	testCollection := testData tests.
	testObject := testData tests first.
	testObject2 := testData tests second.
	testObject3 := testData tests third.
	testSecondLevels := testData tests first secondLevelTestObjects.
	testSecondLevel := testData tests first secondLevelTestObjects first.
	proxyCollection := proxyRepository getCollection: '/tests/'.
	proxyObject := proxyRepository getObject: testObject restUri.
	proxyObject2 := proxyRepository getObject: testObject2 restUri.
	proxyObject3 := proxyRepository getObject: testObject3 restUri.
	proxySecondLevels := proxyRepository getCollection:
		testObject restUri, '/secondLevelTestObjects'.
	proxySecondLevels2 := proxyRepository getCollection:
		testObject2 restUri, '/secondLevelTestObjects'.
	proxySecondLevel := proxyRepository getObject: testSecondLevel restUri.! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/11/2009 14:45'!
testDoubleCollection
	"Monitoring a request twice counts only once"

	2 timesRepeat: [proxyCollection reload].
	self
		should: (proxyRepository monitoringState isKindOf: RestCollectionPredictionState);
		should: (proxyRepository monitoringState collection = proxyCollection).! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/11/2009 14:45'!
testDoubleObject
	"Monitoring a request twice counts only once"

	2 timesRepeat: [proxyObject reload].
	self
		should: (proxyRepository monitoringState isKindOf: RestObjectPredictionState);
		should: (proxyRepository monitoringState object = proxyObject).! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/11/2009 14:45'!
testObjectWithProperty
	"Monitoring a object request and then one of its properties"

	proxySecondLevel reload.
	proxyObject reload.
	self
		should: (proxyRepository monitoringState isKindOf: RestObjectPropertyPredictionState);
		should: (proxyRepository monitoringState object = proxySecondLevel);
		should: (proxyRepository monitoringState property = proxyObject).! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:13'!
testPrefetchCollection

	"Monitoring two objects of a collection triggers prefetch of the collection"
	proxyCollection reload.
	proxyObject reload.
	self
		should: (proxyRepository monitoringState isKindOf: RestObjectPredictionState);
		should: proxyCollection isLoaded;
		should: proxyObject isLoaded;
		should: proxyObject2 isLoaded;
		should: proxyObject3 isLoaded;
		should: RestSocket counter = 2.! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:13'!
testPrefetchCollectionWithinObject

	"Monitoring a child of a collection that is in a proxy object should lead to collection prediction and monitoring another child should trigger collection prefetch"
	proxyObject reload.
	proxySecondLevels reload.
	proxySecondLevels first reload.
	self
		should: (proxyRepository monitoringState isKindOf: RestObjectPredictionState);
		should: proxyObject isLoaded;
		should: proxySecondLevels isLoaded;
		should: proxySecondLevels first isLoaded;
		should: proxySecondLevels second isLoaded;
		should: proxySecondLevels third isLoaded;
		should: RestSocket counter = 3.! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/11/2009 13:52'!
testSimpleCollection
	"A request should be monitored"

	self should: (proxyRepository monitoringState isKindOf: RestStartPredictionState).
	proxyCollection reload.
	self
		should: (proxyRepository monitoringState isKindOf: RestCollectionPredictionState);
		should: (proxyRepository monitoringState collection = proxyCollection).! !

!RestPrefetchTest methodsFor: 'tests' stamp: 'cs 6/11/2009 13:52'!
testSimpleObject
	"A request should be monitored"

	self should: (proxyRepository monitoringState isKindOf: RestStartPredictionState).
	proxyObject reload.
	self
		should: (proxyRepository monitoringState isKindOf: RestObjectPredictionState);
		should: (proxyRepository monitoringState object = proxyObject).! !

RestTest subclass: #RestProxyCollectionTest
	instanceVariableNames: 'sut testObject sut2 testData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyCollectionTest methodsFor: 'running' stamp: 'cs 5/28/2009 16:53'!
setUp
	"Install a handler for http service. Add a testObject to the database."
	
	| repository |
	super setUp.
	testData := RestTestRoot testData.
	repository := RestProxyRepository fromString: self class url.
	RestHttpService resource installHandler: (RestMockResourceHttpHandler with: testData).
	testObject := testData tests first.
	sut := repository getCollection: ('/tests/{1}/secondLevelTestObjects' format: {(testObject id)}).
	sut2 := repository getCollection: ('/tests2/{1}/secondLevelTestObjects' format: {(testData tests2 first id)})! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:14'!
testAddRestObject

	| newObject size |
	newObject := Dictionary with: 'userName' -> 'harry potter'.
	size := sut size.
	sut addNew: newObject.
	self
		should: sut size = (size + 1);
		should: sut last userName = (newObject at: 'userName');
		should: testObject secondLevelTestObjects size = (size + 1);
		should: testObject secondLevelTestObjects last userName = (newObject at: 'userName').! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:17'!
testAutomaticReloadOnAdd

	| newObject size |
	size := sut size.
	newObject := testObject addNewSecondLevelTestObject: (Dictionary with: 'userName' -> 'hairy potter').
	sut reload.
	self
		should: sut size = (size + 1);
		should: sut last userName = newObject userName.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:17'!
testDeleteRestObject

	| oldSize |
	oldSize := sut size.
	sut remove: sut first ifAbsent: [self fail].
	self
		should: sut size = (oldSize - 1);
		should: testObject secondLevelTestObjects size = (oldSize - 1).! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 3/17/2009 16:54'!
testGetRestObjects

	| done |
	done := false.
	sut do: [:each | done := true].
	self
		should: done;
		should: sut first userName = testObject secondLevelTestObjects first userName.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:16'!
testReloadRestObjects

	| oldSize |
	oldSize := sut size.
	self should: sut last userName = testObject secondLevelTestObjects last userName.
		
	sut first delete.
	"sut reload. should be done automatically."
	self 
		should: sut size = (oldSize - 1);
		should: sut2 isEmpty.! !

RestTest subclass: #RestProxyObjectTest
	instanceVariableNames: 'sut testObject testData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyObjectTest methodsFor: 'running' stamp: 'cs 5/28/2009 16:51'!
setUp
	"Install a handler for http service. Add a testObject to the database."
	
	super setUp.
	testData := RestTestRoot testData.
	RestHttpService resource installHandler: (RestMockResourceHttpHandler with: testData).
	testObject := testData tests first.
	sut := (RestProxyObject fromPath: '/tests/' , testObject id asString) repository: (RestProxyRepository fromString: self class url).
	sut repository cache 
		at: sut restUri
		put: sut.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mig 4/1/2009 16:56'!
testAutomaticReload

	testObject userName: 'automatic updated.'.
	sut reload.
	self should: sut userName = 'automatic updated.'.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'topa 4/6/2009 14:32'!
testConvertingUponSend

	sut userName: ''.
	self should: sut userName = ''.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mig 3/31/2009 17:45'!
testDeferCommit

	self shouldnt: testObject userName = 'User Name A'.
	
	sut deferCommit: [
		sut userName: 'User Name A'.
		self shouldnt: testObject userName = 'User Name A'.
		sut userName: 'User Name B'.
		self shouldnt: testObject userName = 'User Name B' ].

	self should: testObject userName = 'User Name B'.
! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'cs 5/28/2009 16:52'!
testDeleteRestObject

	| oldCount |
	oldCount := testData tests size.
	sut delete.
	self should: testData tests size = (oldCount - 1).
	[(RestProxyObject fromPath: '/tests/' , testObject id asString) title]
		on: Exception
		do: [ ^ self ].
	self fail.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:55'!
testGetRestObject

	self
		should: sut userName = testObject userName;
		should: sut id = testObject id;
		should: 
			sut secondLevelTestObjects size = testObject secondLevelTestObjects size.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'cs 6/12/2009 16:12'!
testRestObjectReference

	| cache sut2 sut3 oldUri oldSize |
	cache := sut repository cache.
	sut2 := sut secondLevelTestObjects first.
	oldUri := sut2 restUri.
	oldSize := testObject secondLevelTestObjects size.
	self
		should: sut = sut2 testObject;
		should: (cache includesKey: oldUri).
	sut3 := (RestProxyObject
		fromPath: '/tests/', testData tests second id asString)
		repository: sut repository.
	cache 
		at: sut3 restUri
		put: sut3.
	self
		should: testData tests second secondLevelTestObjects isEmpty;
		should: testObject secondLevelTestObjects first testObject = testObject.
	sut2 testObject: sut3.
	self
		should: testData tests second secondLevelTestObjects first testObject = testData tests second;
		should: testObject secondLevelTestObjects size = (oldSize - 1);
		should: sut3 = sut2 testObject;
		shouldnt: (cache includesKey: oldUri);
		should: (cache includesKey: sut2 restUri).! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/31/2009 15:42'!
testUpdateRestObject

	| sut2 |
	sut userName: 'New User Name!!'.
	self should: testObject userName = 'New User Name!!'.
	
	sut2 := (RestProxyObject
		fromPath: '/tests/' , testObject id asString)
		repository: sut repository.
	self should: sut2 userName = 'New User Name!!'! !

RestTest subclass: #RestProxyRepositoryTest
	instanceVariableNames: 'sut testData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyRepositoryTest methodsFor: 'running' stamp: 'cs 5/28/2009 16:53'!
setUp
	"Install a handler for http service. Add a testObject to the database."
	
	testData := RestTestRoot testData.
	super setUp.
	RestHttpService resource installHandler: (RestMockResourceHttpHandler with: testData).
	sut := RestProxyRepository fromString: self class url.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 5/28/2009 17:55'!
testAdd

	| object testObject oldCount |
	oldCount := testData tests size.
	object := sut 
		addObject: 'tests/'
		with: (Dictionary with: 'userName' -> 'New Test for Factory').
	testObject := testData tests last.
	self
		should: testData tests size = (oldCount + 1);
		should: object userName = testObject userName;
		should: object id = testObject id.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 5/28/2009 17:51'!
testGet

	| object testObject |
	testObject := testData tests first.
	object := sut getObject: 'tests/' , testObject id asString.
	self
		should: object userName = testObject userName;
		should: object id = testObject id! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 5/28/2009 17:52'!
testGetCollection

	| testObjects collection |
	testObjects := testData tests.
	collection := sut getCollection: 'tests/'.
	self should: collection size = testObjects size.
	collection do: [:eachSut | 
		self should: (testObjects anySatisfy: [:eachTestObject |
			eachSut id = eachTestObject id and:
				[eachSut userName = eachTestObject userName]])].! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 5/28/2009 17:52'!
testReloadDeletedObject
	| collection collectionSize object mock |
	mock := RestGenericViewMock new.
	collection := sut getCollection: '/tests/'.
	collectionSize := collection size.
	object := sut getObject: '/tests/', testData tests first id asString.
	object addDependent: mock.
	testData tests first delete.
	object reload.
	self
		should: collection size = (collectionSize - 1);
		should: mock lastMessage = #deleted! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 3/18/2009 13:41'!
testSameCollection

	| collection1 collection2 |
	collection1 := sut getCollection: 'tests/'.
	collection2 := sut getCollection: 'tests/'.

	self should: collection1 == collection2.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 5/28/2009 17:53'!
testSameObject

	| object1 object2 |
	object1 := sut getObject: 'tests/', testData tests first id asString.
	object2 := sut getObject: 'tests/', testData tests first id asString.
	self should: object1 == object2.! !

!RestProxyRepositoryTest methodsFor: 'tests' stamp: 'cs 5/28/2009 17:53'!
testSameObjectInHierachy

	| object1 object2 |
	object1 := sut getObject: '/tests/', testData tests first id asString.
	object2 := object1 secondLevelTestObjects first testObject.
	self should: object1 == object2.! !

RestTest subclass: #RestResourceAuthTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestResourceAuthTest methodsFor: 'tests' stamp: 'bs 7/1/2009 12:03'!
testNeedsAuthentication

	| response handler |
	handler := RestMockResourceHttpHandler new.
	handler authentication: RestNeedsAuthentication new.
	RestHttpService resource installHandler: handler.
	
	ActiveHand resetLoginAndPassword.
	response := self get: 'tests'.
	self should: response responseCode = 401.
	
	ActiveHand login: (self class login) password: (self class password).
	response := self get: 'tests'.
	self should: response responseCode = 200.! !

!RestResourceAuthTest methodsFor: 'tests' stamp: 'cs 5/28/2009 16:06'!
testNeedsNoAuthentication

	| response |
	"has needsAuthentication false"
	RestHttpService resource installHandler: RestMockResourceHttpHandler new.
	response := self get: 'tests'.
	self should: response responseCode = 200.! !

RestTest subclass: #RestResourceGetDepthTest
	instanceVariableNames: 'testObject secondLevelTestObject testData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestResourceGetDepthTest methodsFor: 'running' stamp: 'cs 6/2/2009 12:08'!
setUp
	"Install a handler for http service. Add a testObject to the database."
	
	super setUp.
	testData := RestTestRoot testData.
	RestHttpService resource installHandler: (RestMockResourceHttpHandler with: testData).
	testObject := testData tests first.
	secondLevelTestObject := testObject secondLevelTestObjects first.! !

!RestResourceGetDepthTest methodsFor: 'tests' stamp: 'cs 4/29/2009 12:21'!
testGetCollectionWithDepth1

	| response |	
	response := Json readFrom:
		(self get: testObject restUri, '/secondLevelTestObjects?depth=1')
		content readStream.
	self
		should: response isCollection;
		should: response first isString;
		should: response first = secondLevelTestObject restUri.! !

!RestResourceGetDepthTest methodsFor: 'tests' stamp: 'cs 4/29/2009 13:12'!
testGetCollectionWithDepth2

	| response secondLevel |	
	response := Json readFrom:
		(self get: testObject restUri, '/secondLevelTestObjects?depth=2')
		content readStream.
	secondLevel := Json readFrom: (self get: secondLevelTestObject restUri) content readStream.
	self
		should: response isCollection;
		should: response first isDictionary;
		should: response first = secondLevel.! !

!RestResourceGetDepthTest methodsFor: 'tests' stamp: 'cs 4/29/2009 12:04'!
testGetWithDepth0

	| response |	
	response := Json readFrom: (self get: testObject restUri, '?depth=0') content readStream.
	self
		should: response isString;
		should: response = testObject restUri.! !

!RestResourceGetDepthTest methodsFor: 'tests' stamp: 'cs 4/29/2009 13:15'!
testGetWithDepth1

	| response |	
	response := Json readFrom: (self get: testObject restUri, '?depth=1') content readStream.
	self
		should: response isDictionary;
		should: (response at: 'col secondLevelTestObjects') isString.! !

!RestResourceGetDepthTest methodsFor: 'tests' stamp: 'cs 4/29/2009 12:06'!
testGetWithDepth2

	| test |	
	test := Json readFrom: (self get: testObject restUri, '?depth=2') content readStream.
	self
		should: test isDictionary;
		should: (test at: 'col secondLevelTestObjects') isCollection;
		should: (test at: 'col secondLevelTestObjects') first isString;
		should: (test at: 'col secondLevelTestObjects') first = secondLevelTestObject restUri.! !

!RestResourceGetDepthTest methodsFor: 'tests' stamp: 'cs 4/29/2009 12:05'!
testGetWithDepth3

	| test secondLevel |	
	test := Json readFrom: (self get: testObject restUri, '?depth=3') content readStream.
	secondLevel := Json readFrom: (self get: secondLevelTestObject restUri) content readStream.
	self
		should: test isDictionary;
		should: (test at: 'col secondLevelTestObjects') isCollection;
		should: (test at: 'col secondLevelTestObjects') first isDictionary;
		should: (test at: 'col secondLevelTestObjects') first = secondLevel.! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/5/2009 14:15'!
auth

	^ 'Authorization: Basic dGVzdDoxMjM=', String crlf! !

!RestTest class methodsFor: 'fixture-data' stamp: 'SR 3/9/2009 10:52'!
authUser2Pass

	^ 'Authorization: Basic ', 
		(Base64MimeConverter mimeEncode: (self login2, ':', self password) readStream) upToEnd, String crlf! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/5/2009 14:48'!
authUserPass

	^ 'Authorization: Basic ', 
		(Base64MimeConverter mimeEncode: (self login, ':', self password) readStream) upToEnd, String crlf! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
host

	^ 'localhost'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
ip

	^ '127.0.0.1'! !

!RestTest class methodsFor: 'testing' stamp: 'mfp 3/6/2009 13:40'!
isAbstract

	^ self == RestTest! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/5/2009 14:47'!
login

	^ 'test.user@example.com'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'SR 3/9/2009 10:50'!
login2

	^ 'test.user2@example.com'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'mig 4/1/2009 15:05'!
login3

	^ 'test.user3@example.com'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/5/2009 14:47'!
password

	^ 'foobar123'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'cs 5/22/2009 12:14'!
path

	^ RestMockResourceHttpHandler pathPattern! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
port

	^ 58082! !

!RestTest class methodsFor: 'fixture-data' stamp: 'cs 5/22/2009 14:19'!
url
	
	^ 'http://{1}:{2}@{3}:{4}/{5}/' format: {self login encodeForHTTP. self password encodeForHTTP. self ip. self port. self path}! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:11'!
delete: aPath
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ TestActiveHandRestSocket
		deleteDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:13'!
delete: aPath request: aRequest
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ TestActiveHandRestSocket
		deleteDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:11'!
get: aPath
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ TestActiveHandRestSocket
		getDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:14'!
get: aPath request: aRequest
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ TestActiveHandRestSocket
		getDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/3/2009 21:58'!
jsonDataFrom: someFields
	"Create a string for all fields in the dictionary in JSON."
	
	| stream |
	stream := TextStream with: String new.
	(Dictionary newFrom: someFields) jsonWriteOn: stream.	
	^ stream contents! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:14'!
post: aPath content: aContent
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service. 
	Append the given fields to the request body."

	^ TestActiveHandRestSocket
		postDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:14'!
post: aPath content: aContent request: aRequest
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service.
	 Append the given fields to the request body."

	^ TestActiveHandRestSocket
		postDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:14'!
put: aPath content: aContent
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."
	
	^ TestActiveHandRestSocket
		putDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'bs 9/9/2009 12:14'!
put: aPath content: aContent request: aRequest
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. 
	Append the given fields to the request body."
	
	^ TestActiveHandRestSocket
		putDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest
		content: aContent! !

!RestTest methodsFor: 'running' stamp: 'bs 9/9/2009 12:22'!
setUp

	super setUp.
	currentLogin := ActiveHand login.
	currentPassword := ActiveHand password.
	ActiveHand login: (self class login) password: (self class password).
	
	RestHttpService startOn: self class port.
! !

!RestTest methodsFor: 'running' stamp: 'bs 7/1/2009 11:49'!
tearDown

	RestHttpService stop.
	(currentLogin isNil & currentPassword isNil) 
		ifTrue: [ActiveHand resetLoginAndPassword]
		ifFalse: [ActiveHand login: currentLogin password: currentPassword].
	super tearDown.! !

Object subclass: #RestGenericViewMock
	instanceVariableNames: 'lastMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestGenericViewMock methodsFor: 'accessing' stamp: 'cs 3/18/2009 14:35'!
lastMessage

	^ lastMessage! !

!RestGenericViewMock methodsFor: 'accessing' stamp: 'cs 3/18/2009 14:35'!
lastMessage: anObject

	lastMessage := anObject.! !

!RestGenericViewMock methodsFor: 'updating' stamp: 'cs 3/18/2009 14:35'!
update: aMessage

	super update: aMessage.
	self lastMessage: aMessage.! !

Object subclass: #RestProxyRepositoryMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestProxyRepositoryMock methodsFor: 'private' stamp: 'cs 5/28/2009 14:49'!
deleteObject: anObject 
	RestTestObject all removeFirst! !

!RestProxyRepositoryMock methodsFor: 'instance creation' stamp: 'topa 3/3/2009 18:32'!
getObject: aString

	^ RestProxyObject new! !

RestDynamicVariable subclass: #RestMockVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!
